% \iffalse meta-comment
%
% Copyright (C) <<year>> <<author>>
% -------------------------------------------------------
%
% This file may be distributed and/or modified under the
% conditions of the LaTeX Project Public License, either version 1.3
% of this license or (at your option) any later version.
% The latest version of this license is in:
%
%    http://www.latex-project.org/lppl.txt
%
% and version 1.3 or later is part of all distributions of LaTeX 
% version 2005/12/01 or later.
%
% \fi
%
% \iffalse
%<*documentation>
\documentclass{ltxdoc}
\usepackage{twemojis-extra}
\usepackage{doc}
\usepackage{listings}
\usepackage[hidelinks]{hyperref}
\usepackage{textcomp}
\usepackage{verbatim}
\usepackage{longtable}
\lstset{basicstyle=\ttfamily,commentstyle=\color{white},language=TeX,breaklines=true,breakatwhitespace}

\EnableCrossrefs
\begin{document}
\DocInput{twemojis-extra.dtx}
\end{document}
%</documentation>
\NeedsTeXFormat{LaTeX2e}
\ProvidesPackage{twemojis-extra}[<< year >>/<< '%02d'|format(month) >>/<< '%02d'|format(day) >> v<< version >> LaTeX twemojis (inoffical)]
\RequirePackage{tikz}
\RequirePackage{ifthen}
\RequirePackage{twemojis}
% \fi
%
% \title{twemojis-extra v<< version >>}
% \author{<< author >>}
%
% \maketitle
%
% \begin{abstract}\noindent
% This package includes emojis that were designed to match the official twemoji by Twitter and variations of official twemojis.
% The newly added emojis and variations intend to augment the official emoji set for the purpose of presentations (especially in the context of computer science/IT security).
% \end{abstract}
%
% \section{Usage}
%
% Simply replace |\usepackage{twemojis}| with |\usepackage{twemojis-extra}|.
% Do not load the |twemojis| package explicitly after loading this package.
%
% \section{About}
%
% This package only provides new emojis.
% The |twemojis| package is required (and loaded automatically when loading this package).
% The emojis are registered internally with the commands provided by the |twemojis| package.
% Hence, both the |\twemoji| and |\texttwemoji| commands work exactly the same.
%
% As the provided graphics are intended to be used in presentations (i.e. on a larger scale) I focused on them looking good on said larger scale.
% Some graphics are too detailed for a small-scale usage, like |\twemoji{browser_window}| \twemoji{browser_window}.
% Others like |\twemoji{sheriff_star}| \twemoji{sheriff_star} should be fine to use on a small scale.
%
% Some graphics in this package are simple adaptations of existing twemojis.
% For example, |\twemoji{mag_trans}| \twemoji{mag_trans} which is |\twemoji{mag}| \twemoji{mag} with the ``glass'' removed so it can be put over parts of a slide to signify ``having a closer look at''.
%
% Overall, please keep in mind, that I am not a designer and just trying my best.
% If you want to help with the designs or really need a specific graphic please contact me (best via the issue tracker at \url{https://gitlab.com/rossel.jost/latex-twemojis/-/issues}), we can arrange something \texttwemoji{slightly smiling face}.
%
% \subsection{Changed Twemojis}
%
% Some emojis loaded by this package overload existing ones.
% The original twemoji can always be loaded with the hex-code.
% Here is the current list of overwritten twemojis and the reasoning behind the decision.
%
% \begin{itemize}
%   \item The email twemoji |\twemoji{1f4e7}| \twemoji{1f4e7} has been lowered so that the baseline can be the same for the ``opened email'' variant I added.
%         This way the emoji can be replace in-place without jumping around (for beamer animations).
%         \begin{center}
%             \begin{tikzpicture}
%                 \node[scale=7,inner sep=0pt, draw] (a) at (0,0) {\twemoji{1f4e7}};
%                 \node[scale=7,inner sep=0pt, draw] (a) at (2,0) {\twemoji{email}};
%                 \node[scale=7,inner sep=0pt, draw] (a) at (4,0) {\twemoji{email_open}};
%             \end{tikzpicture}
%         \end{center}
% \end{itemize}
%
% \section{List of Emojis and their Aliases}
% \begin{longtable}{cp{0.9\textwidth}}
<% for unicode, aliases in emojinames_mapping -%>
% \raisebox{-2em}{\twemoji[height=3em]{<<unicode>>}} & <% for alias in aliases %> |<<alias>>|\newline<% endfor -%>\\%
<% endfor %>
% \end{longtable}
% \clearpage
%
<% for line in license_text -%>
% << line >>
<% endfor %>
%
% \StopEventually{}
% \clearpage
% \section{Implementation}

% \begin{macro}{\defineTwemojiExtra}
% Defines an internal |\twemoji ...| command that holds the reference to the actual image.
% Needs the page number and alias under which to find it.
% This differs from the implementation of |\defineTwemoji| in the twemojis package in that the |\defineTwemoji| fails if a |\twemoji ...| command already exists.
% This implementation does simply overwrite existing emojis, as we want to redefine some.
%    \begin{macrocode}
\newcommand{\defineTwemojiExtra}[2]{%
  \ifcsname twemoji #2\endcsname%
    \expandafter\renewcommand\csname twemoji #2\endcsname[1]{%
      \includegraphics[page=#1, ##1]{all-extra-twemojis.pdf}}%
  \else%
    \expandafter\newcommand\csname twemoji #2\endcsname[1]{%
      \includegraphics[page=#1, ##1]{all-extra-twemojis.pdf}}%
  \fi%
}%
%    \end{macrocode}
% \end{macro}

% \begin{comment} % not really relevant in the PDF
% \begin{macro}{Define Twemojis}
% This defines all twemojis this package provides.
%    \begin{macrocode}
<% for (page, alias) in emojinames -%>
\defineTwemojiExtra{<<page>>}{<<alias>>}%
<% endfor %>
%    \end{macrocode}
% \end{macro}
% \end{comment}

% \Finale
\endinput
